<?php
class ControllerExtensionShippingViaDelivery extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('extension/shipping/via_delivery');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('via_delivery', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true));
		}
			
		$data['heading_title'] = $this->language->get('heading_title');
						
		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['text_none'] = $this->language->get('text_none');
		$data['text_dimensions'] = $this->language->get('text_dimensions');
		$data['text_appearance'] = $this->language->get('text_appearance');
		$data['text_payment_status'] = $this->language->get('text_payment_status');

		$data['entry_store_id'] = $this->language->get('entry_store_id');
		$data['entry_secret_token'] = $this->language->get('entry_secret_token');
		$data['entry_status'] = $this->language->get('entry_status');
		$data['entry_sort_order'] = $this->language->get('entry_sort_order');
		$data['entry_weight'] = $this->language->get('entry_weight');
		$data['entry_width'] = $this->language->get('entry_width');
		$data['entry_height'] = $this->language->get('entry_height');
		$data['entry_length'] = $this->language->get('entry_length');
		$data['entry_h1_button'] = $this->language->get('entry_h1_button');
		$data['entry_payment_status'] = $this->language->get('entry_payment_status');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');
		
		$app = $this->getApp();
		
		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/shipping/via_delivery', 'token=' . $this->session->data['token'], true)
		);

		$data['action'] = $this->url->link('extension/shipping/via_delivery', 'token=' . $this->session->data['token'], true);

		$data['cancel'] = $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=shipping', true);

		if (isset($this->request->post['via_delivery_store_id'])) {
			$data['via_delivery_store_id'] = $this->request->post['via_delivery_store_id'];
		} else {
			$data['via_delivery_store_id'] = $this->config->get('via_delivery_store_id');
		}
		
		if (isset($this->request->post['via_delivery_secret_token'])) {
			$data['via_delivery_secret_token'] = $this->request->post['via_delivery_secret_token'];
		} else {
			$data['via_delivery_secret_token'] = $this->config->get('via_delivery_secret_token');
		}

		if (isset($this->request->post['via_delivery_status'])) {
			$data['via_delivery_status'] = $this->request->post['via_delivery_status'];
		} else {
			$data['via_delivery_status'] = $this->config->get('via_delivery_status');
		}

		if (isset($this->request->post['via_delivery_sort_order'])) {
			$data['via_delivery_sort_order'] = $this->request->post['via_delivery_sort_order'];
		} else {
			$data['via_delivery_sort_order'] = $this->config->get('via_delivery_sort_order');
		}
		
		if (isset($this->request->post['via_delivery_weight'])) {
			$data['via_delivery_weight'] = $this->request->post['via_delivery_weight'];
		} else {
			$data['via_delivery_weight'] = $this->config->get('via_delivery_weight');
		}
		
		if (isset($this->request->post['via_delivery_width'])) {
			$data['via_delivery_width'] = $this->request->post['via_delivery_width'];
		} else {
			$data['via_delivery_width'] = $this->config->get('via_delivery_width');
		}
		
		if (isset($this->request->post['via_delivery_height'])) {
			$data['via_delivery_height'] = $this->request->post['via_delivery_height'];
		} else {
			$data['via_delivery_height'] = $this->config->get('via_delivery_height');
		}
		
		if (isset($this->request->post['via_delivery_length'])) {
			$data['via_delivery_length'] = $this->request->post['via_delivery_length'];
		} else {
			$data['via_delivery_length'] = $this->config->get('via_delivery_length');
		}
		
		if (isset($this->request->post['via_delivery_h1_button'])) {
			$data['via_delivery_h1_button'] = $this->request->post['via_delivery_h1_button'];
		} else {
			$data['via_delivery_h1_button'] = $this->config->get('via_delivery_h1_button');
		}
		
		if (isset($this->request->post['via_delivery_payment_status'])) {
			$data['via_delivery_payment_status'] = $this->request->post['via_delivery_payment_status'];
		} else {
			$data['via_delivery_payment_status'] = $this->config->get('via_delivery_payment_status');
		}
				
		$this->load->model('localisation/order_status');
		
		$data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('extension/shipping/via_delivery', $data));
	}
	
	# Application
	public function getApp(){
		
		require DIR_SYSTEM . 'library/via/autoload.php';
				
		$app = new Ipol\Viadelivery\Via\ViaApplication(
			$this->config->get('via_delivery_store_id') ? $this->config->get('via_delivery_store_id') : '', //client_id
			$this->config->get('via_delivery_secret_token') ? $this->config->get('via_delivery_secret_token') : '', //client_secret
			false, //true – for test api, false, for production
			50, //timeout for curl (sec)
			null, //implement of Ipol\Via\Api\Entity\EncoderInterface – used if site can work not in UTF-8
			null, // implement of  Ipol\Via\Core\Entity \CacheInterface – cache or die :[
			null // implement of  Ipol\Via\Api\Entity\LoggerInterface – used for logging 
		);
		
		return $app;
	}
	
	public function save() {
		$json = array();
		
		if(isset($this->request->post['PointInfo']) and !empty($this->request->post['PointInfo'])){
			$json['price'] = $this->currency->format($this->request->post['PointInfo']['price'], $this->session->data['currency']);
			
			$this->session->data['via'] = $this->request->post['PointInfo'];
			$json['via'] = $this->session->data['via'];
		}
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
	
	# Order send via
	public function sendVia(){
		$json = array();
		
		$this->load->language('extension/shipping/via_delivery');
		
		if($this->request->post['order_id']){
			$this->load->model('sale/order');
			$this->load->model('catalog/product');
			$this->load->model('extension/shipping/via_delivery');
			
			$order_id = $this->request->post['order_id'];
			$order_info = $this->model_sale_order->getOrder($order_id);
			$order_totals = $this->model_sale_order->getOrderTotals($order_id);
			$products_orders = $this->model_sale_order->getOrderProducts($order_id);
			$via_info = $this->model_extension_shipping_via_delivery->getOrder($order_id);
			
			$priceGoods = 0;
			$priceDiscount = 0;
			$priceDiscountTwo = 0;
			
			foreach($order_totals as $total){
				if($total['code'] == 'total'){
					$priceGoods += $total['value'];
				}elseif($total['code'] == 'shipping'){
					$priceShipping = $total['value'];
					$priceGoods = $priceGoods - $total['value'];
				}elseif($total['code'] == 'coupon'){
					$priceDiscount += $total['value'];
				}elseif($total['code'] == 'voucher'){
					$priceDiscountTwo += $total['value'];
				}
			}
									
			$app = $this->getApp();
						
			if($this->request->post['status'] == 0){
				$statusVia = 1;
				$statusMain = 'accepted';
			}else{
				$statusVia = 0;
				$statusMain = 'declined';
			}
			
			$payed = 0;
			
			if($this->config->get('via_delivery_payment_status') && isset($this->config->get('via_delivery_payment_status')[0]) && !empty($this->config->get('via_delivery_payment_status')[0])){
				if(in_array($order_info['order_status_id'], $this->config->get('via_delivery_payment_status'))){
					$payed = $priceShipping + $priceGoods;
				}
			}
			
			$fullName = $order_info['firstname'] . ' ' . $order_info['lastname'];
			$fullName = trim($fullName);
			
			$receiver = new \Ipol\Viadelivery\Core\Order\Receiver();
			$receiver->setFullName($fullName)
				->setEmail($order_info['email'])
				->setPhone($order_info['telephone']);
			$receiverCollection = new \Ipol\Viadelivery\Core\Order\ReceiverCollection();
			$receiverCollection->add($receiver);

			$payment = new \Ipol\Viadelivery\Core\Order\Payment();
			
			$payment->setDelivery(new \Ipol\Viadelivery\Core\Entity\Money($priceShipping, $order_info['currency_code']))
				->setGoods(new \Ipol\Viadelivery\Core\Entity\Money($priceGoods, $order_info['currency_code']))
				->setPayed(new \Ipol\Viadelivery\Core\Entity\Money($payed, $order_info['currency_code'])); //how many was pre-payed online
			
			if($this->config->get('via_delivery_payment_status') && isset($this->config->get('via_delivery_payment_status')[0]) && !empty($this->config->get('via_delivery_payment_status')[0])){
				if(in_array($order_info['order_status_id'], $this->config->get('via_delivery_payment_status'))){
					$datePayed = $this->model_extension_shipping_via_delivery->getOrderDatePayed($order_id, $order_info['order_status_id']);
					$payment->setField('datePaid', new \DateTime($datePayed));
				}
			}

			$coreItemCollection = new \Ipol\Viadelivery\Core\Order\ItemCollection();
			
			$total_products = count($products_orders);
			
			$priceDiscountFloatRoundTotal = 0;
			$priceDiscountFloatNotRound = 0;
			
			$keysProduct = array_keys($products_orders);
			$lastKeyProduct = array_pop($keysProduct);
			
			foreach ($products_orders as $key => $product) {
				$coreItem = new \Ipol\Viadelivery\Core\Order\Item(); //core product
				//-------------------------------------------
				//logic for non-int product quantity like metric or liquid products and so for
				$tax = $product['tax']*$product['quantity'];
				$vatRate = ($tax*100)/($product['price']*$product['quantity']);
				
				$product_info = $this->model_catalog_product->getProduct($product['product_id']);
								
				$width = ($product_info['width'] > 0) ? $this->length->convert($product_info['width'], $product_info['length_class_id'],2) : $this->config->get('via_delivery_width');
				$height = ($product_info['height'] > 0) ? $this->length->convert($product_info['height'], $product_info['length_class_id'],2) : $this->config->get('via_delivery_height');
				$length = ($product_info['length'] > 0) ? $this->length->convert($product_info['length'], $product_info['length_class_id'],2) : $this->config->get('via_delivery_length');
				
				$weight = ($product_info['weight'] > 0) ? $this->weight->convert($product_info['weight'], $product_info['weight_class_id'], 2)  : $this->config->get('via_delivery_weight');
				$weight = $weight*$product['quantity'];
				
				if($priceDiscount < 0 && $key == 0){
					$priceDiscount = ($product['price']*$product['quantity']) + $priceDiscount;
					if($vatRate > 0){
						$tax_price = ($priceDiscount*$vatRate)/100;
						$priceDiscount = $priceDiscount + $tax_price;
					}
				}else{
					$priceDiscount = ($product['price']*$product['quantity']) + $tax;
				}
				
				if($priceDiscountTwo < 0 && $key == 0){
					$priceDiscount = $priceDiscount + $priceDiscountTwo;
				}
				
				$priceDiscountFloatNotRound += $priceDiscount;
				$priceDiscount = round($priceDiscount, 2);
				$priceDiscountFloatRoundTotal += $priceDiscount;
				
				if($lastKeyProduct == $key){
					$priceDiscountFloatNotRound =  round($priceDiscountFloatNotRound, 2);
					$difference = $priceDiscountFloatNotRound - $priceDiscountFloatRoundTotal;
					$priceDiscount = $priceDiscount + $difference;
				}
				
				$price = ($product['price']*$product['quantity']) + $tax;
				
				if($product['quantity'] > 1){
					$product['name'] = $product['name'] . ' x ' . $product['quantity'];
				}
																
				//---------------------------------------------
				$coreItem->setName($product['name'])
					->setWeight($weight) //gram, optional
					->setQuantity((int)1)
					->setWidth($width) //mm optional
					->setHeight($height) //mm optional
					->setLength($length) //mm optional
					->setPrice(new \Ipol\Viadelivery\Core\Entity\Money($priceDiscount, $order_info['currency_code'])) //price for one product with all discounts
					->setField('basePrice', new \Ipol\Viadelivery\Core\Entity\Money($price, $order_info['currency_code']))
					->setId($product['product_id']) //product id int in documentation - need to check if it works with strings
					->setBarcode(null) //optional
					->setVatRate($vatRate); //int, -1 for no VAT (0 for 0%)

				$coreItemCollection->add($coreItem);
			}

			$corder = new \Ipol\Viadelivery\Core\Order\Order();
			$corder->setLink($order_id) //order id for inner registration in API and later for order status update
			->setField('pointUuid', $via_info['point_id'])
				->setField('arErrors', [])
				->setField('shippingCompanyHandle', "Via.Delivery")
				->setField('fulfillmentStatus',
					$statusMain) //accepted - to send or update, and 'declined' - to decline sent order
				->setNumber($order_id) // order number in CMS that user will see in ViaDelivery
				->setItems($coreItemCollection)
				->setReceivers($receiverCollection)
				->setPayment($payment);
						
			$coreOrder = $app->sendOrder($corder);
			
			$this->log->write($coreOrder);
			
			if($coreOrder->isSuccess() == false){
				$json['error'] = $coreOrder->getError();
			}else{
				$json['success'] = $this->language->get('text_success_order');
				$this->model_extension_shipping_via_delivery->updOrderStatus($order_id, $statusVia);
			}
			
		}else{
			$json['error'] = $this->language->get('error_order_id');
		}

        $this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
	
	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/shipping/via_delivery')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
	
	# table orders
	public function install() {
		$this->db->query("CREATE TABLE IF NOT EXISTS `via_orders`
		(
			`id`                            int(11) NOT NULL auto_increment PRIMARY KEY,
			`order_id`                      int(11) NOT NULL,
			`point_id`                      varchar(255) NOT NULL,
			`address`                       varchar(255) NOT NULL,
			`status`                        int(11) NOT NULL DEFAULT '0',
			`pin`							int(11) NOT NULL
		) DEFAULT CHARSET=utf8 COLLATE=utf8_general_ci ;");
	}
	
	public function uninstall() {
		$this->db->query("DROP TABLE IF EXISTS `via_orders`");
	}
}