<?php echo $header; ?><?php echo $column_left; ?>
<div id="content">
  <div class="page-header">
    <div class="container-fluid">
      <div class="pull-right">
        <button type="submit" form="form-via-delivery" data-toggle="tooltip" title="<?php echo $button_save; ?>" class="btn btn-primary"><i class="fa fa-save"></i></button>
        <a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $button_cancel; ?>" class="btn btn-default"><i class="fa fa-reply"></i></a></div>
      <h1><?php echo $heading_title; ?></h1>
      <ul class="breadcrumb">
        <?php foreach ($breadcrumbs as $breadcrumb) { ?>
        <li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
        <?php } ?>
      </ul>
    </div>
  </div>
  <div class="container-fluid">
    <?php if ($error_warning) { ?>
    <div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
      <button type="button" class="close" data-dismiss="alert">&times;</button>
    </div>
    <?php } ?>
    <div class="panel panel-default">
      <div class="panel-heading">
        <h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $text_edit; ?></h3>
      </div>
      <div class="panel-body">
        <form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-via-delivery" class="form-horizontal">
		  <div class="form-group">
            <label class="col-sm-2 control-label" for="input-store-id"><?php echo $entry_store_id; ?></label>
            <div class="col-sm-10">
              <input type="text" name="via_delivery_store_id" value="<?php echo $via_delivery_store_id; ?>" id="input-store-id" class="form-control" />
            </div>
          </div>
		  <div class="form-group">
            <label class="col-sm-2 control-label" for="input-secret-token"><?php echo $entry_secret_token; ?></label>
            <div class="col-sm-10">
              <input type="text" name="via_delivery_secret_token" value="<?php echo $via_delivery_secret_token; ?>" id="input-secret-token" class="form-control" />
            </div>
          </div>
          <div class="form-group">
            <label class="col-sm-2 control-label" for="input-status"><?php echo $entry_status; ?></label>
            <div class="col-sm-4">
              <select name="via_delivery_status" id="input-status" class="form-control">
                <?php if ($via_delivery_status) { ?>
                <option value="1" selected="selected"><?php echo $text_enabled; ?></option>
                <option value="0"><?php echo $text_disabled; ?></option>
                <?php } else { ?>
                <option value="1"><?php echo $text_enabled; ?></option>
                <option value="0" selected="selected"><?php echo $text_disabled; ?></option>
                <?php } ?>
              </select>
            </div>
			<label class="col-sm-2 control-label" for="input-sort-order"><?php echo $entry_sort_order; ?></label>
            <div class="col-sm-4">
              <input type="number" name="via_delivery_sort_order" value="<?php echo $via_delivery_sort_order; ?>" id="input-sort-order" class="form-control" />
            </div>
          </div>
		  <hr>
		  <div class="col-sm-6">
			  <div class="alert alert-info" align="center" role="alert">
				<?php echo $text_dimensions; ?>
			  </div>
			  <div class="form-group">
				<label class="col-sm-4 control-label" for="input-weight"><?php echo $entry_weight; ?></label>
				<div class="col-sm-8">
				  <input type="text" name="via_delivery_weight" value="<?php echo $via_delivery_weight; ?>" id="input-weight" class="form-control" />
				</div>
			  </div>
			  <div class="form-group">
				<label class="col-sm-4 control-label" for="input-width"><?php echo $entry_width; ?></label>
				<div class="col-sm-8">
				  <input type="text" name="via_delivery_width" value="<?php echo $via_delivery_width; ?>" id="input-width" class="form-control" />
				</div>
			  </div>
			  <div class="form-group">
				<label class="col-sm-4 control-label" for="input-height"><?php echo $entry_height; ?></label>
				<div class="col-sm-8">
				  <input type="text" name="via_delivery_height" value="<?php echo $via_delivery_height; ?>" id="input-height" class="form-control" />
				</div>
			  </div>
			  <div class="form-group">
				<label class="col-sm-4 control-label" for="input-length"><?php echo $entry_length; ?></label>
				<div class="col-sm-8">
				  <input type="text" name="via_delivery_length" value="<?php echo $via_delivery_length; ?>" id="input-length" class="form-control" />
				</div>
			  </div>
		  </div>
		  <div class="col-sm-6">
			<div class="alert alert-info" align="center" role="alert">
			  <?php echo $text_appearance; ?>
			</div>
			<div class="form-group">
				<label class="col-sm-4 control-label" for="input-h1-button"><?php echo $entry_h1_button; ?></label>
				<div class="col-sm-8">
				  <input type="text" name="via_delivery_h1_button" value="<?php echo $via_delivery_h1_button; ?>" id="input-h1-button" class="form-control" />
				</div>
			</div>
			<div class="alert alert-info" align="center" role="alert">
			  <?php echo $text_payment_status; ?>
			</div>
			<div class="form-group">
				<label class="col-sm-4 control-label" for="binding-payment-status"><?php echo $entry_payment_status; ?></label>
				<div class="col-sm-8">
				  <select name="via_delivery_payment_status[]" multiple class="form-control" id="binding-payment-status">
					<option></option>
					<?php foreach($order_statuses as $status){ ?>
					<?php if(in_array($status['order_status_id'], $via_delivery_payment_status)){ ?>
					<option value="<?php echo $status['order_status_id']; ?>" selected="selected"><?php echo $status['name']; ?></option>
					<?php }else{ ?>
					<option value="<?php echo $status['order_status_id']; ?>"><?php echo $status['name']; ?></option>
					<?php } ?>
					<?php } ?>
				  </select>
				</div>
			</div>
		  </div>
        </form>
      </div>
    </div>
  </div>
</div>
<?php echo $footer; ?> 