<?php
class ControllerExtensionShippingViaDelivery extends Controller {
	public function popup() {
		
		$this->load->language('extension/shipping/via_delivery');
		$this->load->model('extension/shipping/via_delivery');
		
		$priceDiscount = 0;
		$priceDiscountTwo = 0;
		
		$this->load->model('extension/extension');

		$order_data = array();
		
		$totals = array();
		$taxes = $this->cart->getTaxes();
		$total = 0;

		// Because __call can not keep var references so we put them into an array.
		$total_data = array(
			'totals' => &$totals,
			'taxes'  => &$taxes,
			'total'  => &$total
		);
		
		$sort_order = array();

		$results = $this->model_extension_extension->getExtensions('total');

		foreach ($results as $key => $value) {
			$sort_order[$key] = $this->config->get($value['code'] . '_sort_order');
		}

		array_multisort($sort_order, SORT_ASC, $results);

		foreach ($results as $result) {
			if ($this->config->get($result['code'] . '_status')) {
				$this->load->model('extension/total/' . $result['code']);

				// We have to put the totals in an array so that they pass by reference.
				$this->{'model_extension_total_' . $result['code']}->getTotal($total_data);
			}
		}

		$sort_order = array();

		foreach ($totals as $key => $value) {
			$sort_order[$key] = $value['sort_order'];
		}

		array_multisort($sort_order, SORT_ASC, $totals);

		$order_data['totals'] = $totals;
		
		foreach($order_data['totals'] as $row){
			if($row['code'] == 'coupon'){
				$priceDiscount += $row['value'];
			}elseif($row['code'] == 'voucher'){
				$priceDiscountTwo += $row['value'];
			}
		}
				
		$totalPrice = $this->cart->getTotal();
		$mainWeight = $this->cart->getWeight() ? $this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), 2) : $this->config->get('via_delivery_weight');
		$dimansions = $this->model_extension_shipping_via_delivery->getDimensions();
		
		# Location
		$cityTo = '';
		$countryTo = '';
		$zoneTo = '';
		$zoneCode = '';
		$postCode = '';
		
		if(isset($this->session->data['shipping_address']['city'])){
			$cityTo = $this->session->data['shipping_address']['city'];
			$countryTo = $this->session->data['shipping_address']['iso_code_2'];
			$zoneTo = $this->session->data['shipping_address']['zone'];
			$zoneCode = $this->session->data['shipping_address']['zone_code'];
			$postCode = $this->session->data['shipping_address']['postcode'];
		}elseif(isset($this->session->data['payment_address']['city'])){
			$cityTo = $this->session->data['payment_address']['city'];
			$countryTo = $this->session->data['payment_address']['iso_code_2'];
			$zoneTo = $this->session->data['payment_address']['zone'];
			$zoneCode = $this->session->data['payment_address']['zone_code'];
			$postCode = $this->session->data['payment_address']['postcode'];
		}elseif(isset($this->request->get['order_id']) && $this->request->get['order_id'] != 0){
			$this->load->model('checkout/order');
			$order_info = $this->model_checkout_order->getOrder($this->request->get['order_id']);
			
			$cityTo = $order_info['shipping_city'];
			$countryTo = $order_info['shipping_iso_code_2'];
			$zoneTo = $order_info['shipping_zone'];
			$postCode = $order_info['shipping_postcode'];
			
			$pointId = $this->model_extension_shipping_via_delivery->getPointId($this->request->get['order_id']);
			
			if(empty($pointId)){
				unset($pointId);
			}
		}
		
		if (isset($this->session->data['via']) and !empty($this->session->data['via'])) {
			$pointId = $this->session->data['via']['id'];
		}
		
		if(!empty($cityTo) or !empty($postCode)){
			$locationName = $countryTo . ', ' . $zoneTo . ', ' . $zoneCode . ', ' . $cityTo . ', ' . $postCode;
		}
				
		# Application load
		$app = $this->model_extension_shipping_via_delivery->getApp();
		
		# Shipment object
		$coreShipment = new \Ipol\Viadelivery\Core\Delivery\Shipment();

        $toLocation = new \Ipol\Viadelivery\Core\Delivery\Location('cms');

		if($countryTo == 'US'){
			$region = $zoneCode;
		}else{
			$region = $zoneTo;
		}

		if(isset($locationName)){
			$toLocation->setName($cityTo) //optional - theoretically server can make calculation for all existing points
			->setRegion($region)		//optional - theoretically server can make calculation for all existing points
			->setZip($postCode)			//optional - theoretically server can make calculation for all existing points
			->setCountry($countryTo); //optional - theoretically server can make calculation for all existing points
		}
		
        $cargoes = new \Ipol\Viadelivery\Core\Delivery\CargoCollection(\Ipol\Viadelivery\Core\Entity\Packing\ViaDimMerger::class); //it's important to use ViaDimMerger - it implements dimensions merging logic, declared by Via in TechRequirements
        
		$cargo = new \Ipol\Viadelivery\Core\Delivery\Cargo(\Ipol\Viadelivery\Core\Entity\Packing\ViaDimMerger::class); //same as above
       
		$priceDiscountFloatRoundTotal = 0;
		$priceDiscountFloatNotRound = 0;
		
		$keysProduct = array_keys($this->cart->getProducts());
		$lastKeyProduct = array_pop($keysProduct);
		
		foreach ($this->cart->getProducts() as $key => $product) { //loop for processing multiple goods in order, obviously, there must be CMS basketItem collection in place of [1]
            $item = new \Ipol\Viadelivery\Core\Delivery\CargoItem();
			$tax = $this->tax->getTax($product['price']*$product['quantity'], $product['tax_class_id']);
			$vatRate = ($tax*100)/($product['price']*$product['quantity']);
			
			$width = ($product['width'] > 0) ? $this->length->convert($product['width'], $product['length_class_id'],2) : $this->config->get('via_delivery_width');
			$height = ($product['height'] > 0) ? $this->length->convert($product['height'], $product['length_class_id'],2) : $this->config->get('via_delivery_height');
			$length = ($product['length'] > 0) ? $this->length->convert($product['length'], $product['length_class_id'],2) : $this->config->get('via_delivery_length');
						
			$weight = ($product['weight'] > 0) ? $this->weight->convert($product['weight'], $product['weight_class_id'], 2) : $this->config->get('via_delivery_weight')*$product['quantity'];
			
			if($priceDiscount < 0 && $key == 0){
				$priceDiscount = ($product['price']*$product['quantity']) + $priceDiscount;
					
				if($vatRate > 0){
					$tax_price = ($priceDiscount*$vatRate)/100;
					$priceDiscount = $priceDiscount + $tax_price;
				}
			}else{
				$priceDiscount = ($product['price']*$product['quantity']) + $tax;
			}
			
			if($priceDiscountTwo < 0 && $key == 0){
				$priceDiscount = $priceDiscount + $priceDiscountTwo;
			}
			
			$priceDiscountFloatNotRound += $priceDiscount;
				$priceDiscount = round($priceDiscount, 2);
			$priceDiscountFloatRoundTotal += $priceDiscount;
			
			if($lastKeyProduct == $key){
				$priceDiscountFloatNotRound =  round($priceDiscountFloatNotRound, 2);
				$difference = $priceDiscountFloatNotRound - $priceDiscountFloatRoundTotal;
				$priceDiscount = $priceDiscount + $difference;
			}
			
			$price = ($product['price']*$product['quantity']) + $tax;
																					
            $item->setWidth(floatval($width)) // mm
            ->setHeight(floatval($height)) // mm
            ->setLength(floatval($length)) // mm
            ->setPrice(new \Ipol\Viadelivery\Core\Entity\Money($priceDiscount, $this->session->data['currency'])) //estimated price for insurance
			->setField('basePrice', new \Ipol\Viadelivery\Core\Entity\Money($price, $this->session->data['currency']))
            ->setQuantity((int)1)
                ->setWeight($weight); //gram

            $cargo->add($item);
        }
				
		$cargoes->add($cargo);
		
        $coreShipment->setTo($toLocation)
            ->setCargoes($cargoes);
        if (isset($pointId)) {
            $coreShipment->setPvzIdTo($pointId); //optional - if point id is set, calculation will run for this point, city info will be ignored
        }
		
		# Cache params
		$params = array();
		$params['locationName'] = $locationName;
		$params['totalPrice'] = $totalPrice;
		$params['weight'] = $mainWeight;
		$params['length'] = $dimansions['length'];
		$params['width'] = $dimansions['width'];
		$params['height'] = $dimansions['height'];
		
		$cache = 'via.shipping.calculate.' . md5(implode('', $params));
				
		# Calculate
		if (!$priceMin = $this->cache->get($cache)) {
			$calculate = $app->calculate($coreShipment);
										
			if($calculate->isSuccess() == false){
				$this->log->write($this->language->get('text_calculator') . $calculate->getError());
			}else{
				$priceMin = $calculate->getDeliveryMinPrice();
				$this->cache->set($cache, $priceMin);
			}
		}
		
		if($this->session->data['language'] == 'en-gb'){
			$language = 'en';
		}elseif($this->session->data['language'] == 'ru-ru'){
			$language = 'ru';
		}else{
			$language = 'en';
		}
		
		$mapConfigObj = $app->getMapConfig($coreShipment, $language);
		
		$this->log->write($mapConfigObj);
		
		echo '
		<div class="modal" id="vieModal" tabindex="-1" role="dialog">
		  <div class="modal-dialog" role="document" style="width: 90%">
			<div class="modal-content">
			  <div class="modal-header">
				<h5 class="modal-title"></h5>
				<button type="button" class="close" id="close-modal" style="margin-top:-10px;" data-dismiss="modal" aria-label="Close">
				  <span aria-hidden="true">&times;</span>
				</button>
			  </div>
			  <div class="modal-body" style="height: 550px;">
				<iframe
					style="height: 100%; width: 100%"
					id="viaDeliveryMapFrame"
					frameborder="0"
					src ="' . $mapConfigObj->getFullMapLink() . '"
				></iframe>
				</div>
			</div>
		  </div>
		</div>
		';
	}
	
	public function save() {
		$json = array();
		
		if(isset($this->request->post['PointInfo']) and !empty($this->request->post['PointInfo'])){
			$json['price'] = $this->currency->format($this->request->post['PointInfo']['price'], $this->session->data['currency']);
			$this->session->data['shipping_method']['cost'] = $this->request->post['PointInfo']['price'];
			$this->session->data['via'] = $this->request->post['PointInfo'];
			$this->session->data['via']['address'] = $this->session->data['via']['description'] . " " . $this->session->data['via']['min_days'] . "-" . $this->session->data['via']['max_days'] . " days, " . $this->session->data['via']['full_address'];
			
			$json['via'] = $this->session->data['via'];
		}
		
		$this->response->addHeader('Content-Type: application/json');
		$this->response->setOutput(json_encode($json));
	}
}