<?php
class ModelExtensionShippingViaDelivery extends Model {
	# Application
	public function getApp(){
		
		require DIR_SYSTEM . 'library/via/autoload.php';
				
		$app = new Ipol\Viadelivery\Via\ViaApplication(
			$this->config->get('via_delivery_store_id') ? $this->config->get('via_delivery_store_id') : '', //client_id
			$this->config->get('via_delivery_secret_token') ? $this->config->get('via_delivery_secret_token') : '', //client_secret
			false, //true – for test api, false, for production
			50, //timeout for curl (sec)
			null, //implement of Ipol\Via\Api\Entity\EncoderInterface – used if site can work not in UTF-8
			null, // implement of  Ipol\Via\Core\Entity \CacheInterface – cache or die :[
			null//new \Ipol\Viadelivery\Admin\ToFileLoggerController(DIR_SYSTEM. '../logger.txt') //new Ipol\Viadelivery\Admin\ToFileLoggerController(DIR_SYSTEM.'../logger.txt')
		);
		
		return $app;
	}
	
	public function getPointId($order_id){
		$query = $this->db->query("SELECT point_id FROM via_orders WHERE order_id = '" . (int)$order_id . "'");
		
		return $query->row['point_id'];
	}
	
	public function getOrderProducts($order_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_product WHERE order_id = '" . (int)$order_id . "'");

		return $query->rows;
	}
	
	public function getOrderTotals($order_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "order_total WHERE order_id = '" . (int)$order_id . "' ORDER BY sort_order");

		return $query->rows;
	}
	
	public function getOrderDatePayed($order_id, $order_status_id){
		$query = $this->db->query("SELECT date_added FROM " . DB_PREFIX . "order_history WHERE order_id = '" . (int)$order_id . "' AND order_status_id = '" . (int)$order_status_id . "' ORDER BY order_history_id DESC LIMIT 1");
		
		if ($query->num_rows) {
			return $query->row['date_added'];
		} else {
			return date("Y-m-d H:m:s");
		}
	}
	
	public function getDimensions() {
		$dimensions = array();
		
		$length = 0;
		$width = 0;
		$height = 0;
		
		foreach ($this->cart->getProducts() as $product) {
			$width += $this->length->convert($product['width'], $product['length_class_id'],2);
			$length += $this->length->convert($product['length'], $product['length_class_id'], 2);
			$height += $this->length->convert($product['height'], $product['length_class_id'], 2);
		}
		
		$dimensions['width'] = ($width > 0) ? $width : $this->config->get('via_delivery_width');
		$dimensions['length'] = ($length > 0) ? $length : $this->config->get('via_delivery_length');
		$dimensions['height'] = ($height > 0) ? $height : $this->config->get('via_delivery_height');
		
		return $dimensions;
	}
		
	function getQuote($address) {
		ini_set('error_reporting', E_ALL);
		ini_set('display_errors', 1);
		ini_set('display_startup_errors', 1);
		
		$this->load->language('extension/shipping/via_delivery');
		
		$method_data = array();
						
		if ($this->config->get('via_delivery_status')) {
			$status = true;
		}else{
			$status = false;
		}
		
		if($this->session->data['currency'] != 'RUB' && $this->session->data['currency'] != 'USD'){
			$this->log->write($this->language->get('text_currency_via') . $this->session->data['currency']);
			return $method_data;
		}
		
		$priceDiscount = 0;
		$priceDiscountTwo = 0;
		
		$this->load->model('extension/extension');

		$order_data = array();
		
		$totals = array();
		$taxes = $this->cart->getTaxes();
		$total = 0;

		// Because __call can not keep var references so we put them into an array.
		$total_data = array(
			'totals' => &$totals,
			'taxes'  => &$taxes,
			'total'  => &$total
		);
						
		$sort_order = array();

		$results = $this->model_extension_extension->getExtensions('total');

		foreach ($results as $key => $value) {
			$sort_order[$key] = $this->config->get($value['code'] . '_sort_order');
		}

		array_multisort($sort_order, SORT_ASC, $results);

		foreach ($results as $result) {
			if ($this->config->get($result['code'] . '_status')) {
				$this->load->model('extension/total/' . $result['code']);

				// We have to put the totals in an array so that they pass by reference.
				$this->{'model_extension_total_' . $result['code']}->getTotal($total_data);
			}
		}

		$sort_order = array();

		foreach ($totals as $key => $value) {
			$sort_order[$key] = $value['sort_order'];
		}

		array_multisort($sort_order, SORT_ASC, $totals);

		$order_data['totals'] = $totals;
		
		foreach($order_data['totals'] as $row){
			if($row['code'] == 'coupon'){
				$priceDiscount += $row['value'];
			}elseif($row['code'] == 'voucher'){
				$priceDiscountTwo += $row['value'];
			}
		}
		
		$totalPrice = $this->cart->getTotal();
		$mainWeight = $this->cart->getWeight() ? $this->weight->convert($this->cart->getWeight(), $this->config->get('config_weight_class_id'), 2) : $this->config->get('via_delivery_weight');
		$dimansions = $this->getDimensions();
		
		# Location
		$cityTo = '';
		$countryTo = '';
		$zoneTo = '';
		$zoneCode = '';
		$postCode = '';
		
		if(isset($this->session->data['shipping_address']['city'])){
			$cityTo = $this->session->data['shipping_address']['city'];
			$countryTo = $this->session->data['shipping_address']['iso_code_2'];
			$zoneTo = $this->session->data['shipping_address']['zone'];
			$zoneCode = $this->session->data['shipping_address']['zone_code'];
			$postCode = $this->session->data['shipping_address']['postcode'];
		}elseif(isset($this->session->data['payment_address']['city'])){
			$cityTo = $this->session->data['payment_address']['city'];
			$countryTo = $this->session->data['payment_address']['iso_code_2'];
			$zoneTo = $this->session->data['payment_address']['zone'];
			$zoneCode = $this->session->data['payment_address']['zone_code'];
			$postCode = $this->session->data['payment_address']['postcode'];
		}
						
		if(!empty($cityTo) or !empty($postCode)){
			$locationName = $countryTo . ', ' . $zoneTo . ', ' . $zoneCode . ', ' . $cityTo . ', ' . $postCode;
		}else{
			$this->log->write($this->language->get('text_city_and_postcode'));
			return $method_data;
		}
		
		# Application load
		$app = $this->getApp();
		
		# Shipment object
		$coreShipment = new \Ipol\Viadelivery\Core\Delivery\Shipment();

        $toLocation = new \Ipol\Viadelivery\Core\Delivery\Location('cms');
		
		if($countryTo == 'US'){
			$region = $zoneCode;
		}else{
			$region = $zoneTo;
		}
		
		if(isset($locationName)){
			$toLocation->setName($cityTo) //optional - theoretically server can make calculation for all existing points
			->setRegion($region)		//optional - theoretically server can make calculation for all existing points
			->setZip($postCode)			//optional - theoretically server can make calculation for all existing points
			->setCountry($countryTo); //optional - theoretically server can make calculation for all existing points
		}else{
			$this->log->write($this->language->get('text_city_and_postcode'));
			return $method_data;
		}
		
        $cargoes = new \Ipol\Viadelivery\Core\Delivery\CargoCollection(\Ipol\Viadelivery\Core\Entity\Packing\ViaDimMerger::class); //it's important to use ViaDimMerger - it implements dimensions merging logic, declared by Via in TechRequirements
        
		$cargo = new \Ipol\Viadelivery\Core\Delivery\Cargo(\Ipol\Viadelivery\Core\Entity\Packing\ViaDimMerger::class); //same as above
		
		$priceDiscountFloatRoundTotal = 0;
		$priceDiscountFloatNotRound = 0;
		
		$keysProduct = array_keys($this->cart->getProducts());
		$lastKeyProduct = array_pop($keysProduct);
						
		foreach ($this->cart->getProducts() as $key => $product) { //loop for processing multiple goods in order, obviously, there must be CMS basketItem collection in place of [1]
            $item = new \Ipol\Viadelivery\Core\Delivery\CargoItem();
			$tax = $this->tax->getTax($product['price']*$product['quantity'], $product['tax_class_id']);
			$vatRate = ($tax*100)/($product['price']*$product['quantity']);
			
			$width = ($product['width'] > 0) ? $this->length->convert($product['width'], $product['length_class_id'],2) : $this->config->get('via_delivery_width');
			$height = ($product['height'] > 0) ? $this->length->convert($product['height'], $product['length_class_id'],2) : $this->config->get('via_delivery_height');
			$length = ($product['length'] > 0) ? $this->length->convert($product['length'], $product['length_class_id'],2) : $this->config->get('via_delivery_length');
						
			$weight = ($product['weight'] > 0) ? $this->weight->convert($product['weight'], $product['weight_class_id'], 2) : $this->config->get('via_delivery_weight')*$product['quantity'];
			
			if($priceDiscount < 0 && $key == 0){
				$priceDiscount = ($product['price']*$product['quantity']) + $priceDiscount;
					
				if($vatRate > 0){
					$tax_price = ($priceDiscount*$vatRate)/100;
					$priceDiscount = $priceDiscount + $tax_price;
				}
			}else{
				$priceDiscount = ($product['price']*$product['quantity']) + $tax;
			}
			
			if($priceDiscountTwo < 0 && $key == 0){
				$priceDiscount = $priceDiscount + $priceDiscountTwo;
			}
			
			$priceDiscountFloatNotRound += $priceDiscount;
				$priceDiscount = round($priceDiscount, 2);
			$priceDiscountFloatRoundTotal += $priceDiscount;
			
			if($lastKeyProduct == $key){
				$priceDiscountFloatNotRound =  round($priceDiscountFloatNotRound, 2);
				$difference = $priceDiscountFloatNotRound - $priceDiscountFloatRoundTotal;
				$priceDiscount = $priceDiscount + $difference;
			}
			
			$price = ($product['price']*$product['quantity']) + $tax;
																								
            $item->setWidth(floatval($width)) // mm
            ->setHeight(floatval($height)) // mm
            ->setLength(floatval($length)) // mm
            ->setPrice(new \Ipol\Viadelivery\Core\Entity\Money($priceDiscount, $this->session->data['currency'])) //estimated price for insurance
			->setField('basePrice', new \Ipol\Viadelivery\Core\Entity\Money($price, $this->session->data['currency']))
            ->setQuantity((int)1)
                ->setWeight($weight); //gram

            $cargo->add($item);
        }
				
		$cargoes->add($cargo);
		
        $coreShipment->setTo($toLocation)
            ->setCargoes($cargoes);
			
		# Cache params
		$params = array();
		$params['locationName'] = $locationName;
		$params['totalPrice'] = $totalPrice;
		$params['weight'] = $mainWeight;
		$params['length'] = $dimansions['length'];
		$params['width'] = $dimansions['width'];
		$params['height'] = $dimansions['height'];
			
        if (isset($this->session->data['via']) and !empty($this->session->data['via'])) {
            $coreShipment->setPvzIdTo($this->session->data['via']['id']); //optional - if point id is set, calculation will run for this point, city info will be ignored
			$params['pointId'] = $this->session->data['via']['id'];
        }
				
		$cache = 'via.shipping.calculate.' . md5(implode('', $params));
				
		# Calculate
		if (!$priceMin = $this->cache->get($cache)) {
			$calculate = $app->calculate($coreShipment);
										
			if($calculate->isSuccess() == false){
				$this->log->write($this->language->get('text_calculator') . $calculate->getError());
				return $method_data;
			}else{
				$priceMin = $calculate->getDeliveryMinPrice();
				$this->cache->set($cache, $priceMin);
			}
		}
										
		# button pickpoint
		if($this->config->get('via_delivery_h1_button')){
			$buttonPickpoint = $this->config->get('via_delivery_h1_button');
		}else{
			$buttonPickpoint = 'Pick-up point';
		}
		
		if ($status) {			
			$quote_data = array();

			$quote_data['via_delivery'] = array(
				'code'         => 'via_delivery.via_delivery',
				'title'        => 'Via.Delivery',
				'cost'         => $priceMin,
				'tax_class_id' => 0,
				'buttonPickpoint'	=> $buttonPickpoint,
				'text'         => '<span id="via-cost">' . $this->currency->format($priceMin, $this->session->data['currency']) . '</span>'
			);

			$method_data = array(
				'code'       => 'via_delivery',
				'title'      => 'Via.Delivery',
				'quote'      => $quote_data,
				'sort_order' => $this->config->get('via_delivery_sort_order'),
				'error'      => false
			);
		}

		return $method_data;
	}
}